Subject: Re: What's cooking in git.git (Jun 2021, #07; Wed, 30)

From: Junio C Hamano <[email-masked]>
Date: Fri, 02 Jul 2021 09:05:18 -0700

Ævar Arnfjörð Bjarmason <[email-masked]> writes:

> Yes, they can't be advanced separately, one depends on the other in
> turn. I'm suggesting that the parts that go earlier in the sequence
> could advance before the later parts.

Yes, as long as the bottom half is more stable and ready than the
top half.  When I queued these topics, however, I didn't get that
impression.  After all, if we have to replace the bottom half as
often as the top half, having to maintain two topic branches is a
needless chore.

>> I actually do agree with the objection that www-data is a contrived
>> thing to use in the examples, not because the user www-data is
>> distro specific, but because it involves one physical human user
>> acting on two accounts, instead of two human users interacting with
>> each other.
>
> The www-thing is arbitrary, and I can change that bit, but what do you
> think of what I mentioned at the end of [2], i.e.:
>
>     
>     [...] the purposes of the example in the guide replacing Alice & Bob
>     with You & another version of you removes a lot of potential
>     confusion, we don't need to cover permissions, the other user doing
>     unexpected things like non-ff updates, pruning branches you may have
>     relied on through the --local clone etc.

www-data requiring more privilege than you do require permissions.

I still think two distinct human users coorporating towards the same
goal would make easier-to-follow sample sessions.  IOW, ...

>     It's implicit that both "users" are you, so we only have to discuss the
>     point of the actual example, how to pull and push between two different
>     repos, the "different users" in this case was always a distraction.

... my view of the presence of two distinct human users in the
example is completely opposite from yours---to explain Git as a
platform for inter-developer coordination, it is a crucial part, not
a distraction, to have them as two separate human beings.  It is OK
to pretend, while practicing, that you who are typing to this window
ares playing the role of Tom and you in the other window are playing
the role of Mary, and that would be what learners would do, but the
scenario the learners learn from should resemble more what they
would do in the real world when they become fluent for the learning
experience to be more useful and lasting in their minds., I would
expect.

Thanks.